## taisei 1.4.1+dfsg

=== meson_options.txt ===

option(
    'developer',
    type : 'combo',
    choices : ['true', 'false', 'auto'],
    value : 'false',
    deprecated : ['auto'],
    description : 'Make a "developer" build with cheats and extra debugging features'
)

option('vfs_zip',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Support loading of game data from ZIP packages (requires libzip)'
)

option(
    'enable_zip',
    type : 'boolean',
    deprecated : 'vfs_zip',
    description : 'DEPRECATED: use vfs_zip instead',
)

option(
    'package_data',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Package the game’s assets into a compressed archive (requires vfs_zip)'
)

option(
    'install_relocatable',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Install everything into the same directory, don\'t hardcode absolute paths into the executable. Prefix is assumed to be an empty directory reserved for Taisei in this mode.'
)

option(
    'install_relative',
    type : 'combo',
    choices : ['auto', 'true', 'false'],
    deprecated : 'install_relocatable',
    description : 'DEPRECATED: use install_relocatable instead',
)

option(
    'install_freedesktop',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Install freedesktop.org integration files (launchers, icons, replay file associations, etc.). Mostly relevant for Linux/BSD/etc. desktop systems'
)

option(
    'install_macos_bundle',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'auto', 'false' : 'disabled'},
    description : 'Install into a macOS application bundle'
)

option(
    'macos_bundle',
    type : 'boolean',
    deprecated : 'install_macos_bundle',
    description : 'DEPRECATED: use install_macos_bundle instead',
)

option(
    'install_angle',
    type : 'boolean',
    value : false,
    description : 'Install pre-built ANGLE libraries. Required for Windows/macOS OpenGL ES 2.0/3.0'
)

option(
    'angle_libgles',
    type : 'string',
    description : 'Path to ANGLE\'s libGLESv2 dynamic library (see install_angle)'
)

option(
    'angle_libegl',
    type : 'string',
    description : 'Path to ANGLE\'s libEGL dynamic library (see install_angle)'
)

option(
    'win_console',
    type : 'boolean',
    value : false,
    description : 'Use the console subsystem on Windows'
)

option(
    'static',
    type : 'boolean',
    value : false,
    deprecated : 'prefer_static',
    description : 'DEPRECATED: use prefer_static instead',
)

option(
    'docs',
    type : 'feature',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build and install documentation (requires docutils)'
)

option(
    'shader_transpiler',
    type : 'feature',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Enable shader trans-compilation (requires shaderc)'
)

option(
    'validate_glsl',
    type : 'feature',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Enable validation of GLSL shaders (requires glslc)'
)

option(
    'r_default',
    type : 'combo',
    choices : ['auto', 'gl33', 'gles20', 'gles30', 'null'],
    description : 'Which rendering backend to use by default'
)

option(
    'r_gl33',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build the OpenGL 3.3 Core renderer'
)

option(
    'r_gles20',
    type : 'feature',
    value : 'disabled',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build the OpenGL ES 2.0 renderer (incomplete)'
)

option(
    'r_gles30',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build the OpenGL ES 3.0 renderer'
)

option(
    'r_null',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build the no-op renderer (nothing is displayed). Required for --verify-replay to work properly'
)

option(
    'a_default',
    type : 'combo',
    choices : ['auto', 'sdl', 'null'],
    description : 'Which audio backend to use by default'
)

option(
    'a_sdl',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build the SDL audio backend'
)

option(
    'a_null',
    type : 'feature',
    value : 'auto',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Build the no-op audio backend (silence); you want this on!'
)

option(
    'use_libcrypto',
    type : 'feature',
    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
    description : 'Use libcrypto from OpenSSL for better SHA implementations'
)

option(
    'deprecation_warnings',
    choices : ['default', 'error', 'no-error', 'ignore'],
    type : 'combo',
    description : 'Treatment of deprecation warnings'
)

option(
    'force_vendored_shader_tools',
    type : 'boolean',
    value : false,
    description : 'Build shaderc and spirv-cross CLI tools from subprojects even if system versions exist'
)

option(
    'stages_live_reload',
    type : 'boolean',
    value : false,
    description : 'Enable live-reloading workflow for stages (for development only)'
)

option(
    'gamemode',
    type : 'feature',
    description: 'Integrate with the GameMode daemon, if running'
)
