=== debian/changelog ===
taisei (1.4.1+dfsg-2) unstable; urgency=low

  * Suorce-only upload.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Sun, 16 Mar 2025 07:51:21 +0800

taisei (1.4.1+dfsg-1) unstable; urgency=low

  * Initial release. (Closes: #1083093)

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Mon, 07 Oct 2024 05:40:18 +0800
