=== debian/control ===
Source: taisei
Section: games
Priority: optional
Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               docbook-xsl,
               gamemode-dev,
               libcglm-dev,
               libfreetype-dev,
               libopusfile-dev,
               libpng-dev,
               libsdl2-dev,
               libsdl2-mixer-dev,
               libssl-dev,
               libwebp-dev,
               libzip-dev,
               libzstd-dev,
               meson,
               ninja-build,
               ocl-icd-opencl-dev,
               python3,
               python3-docutils,
               python3-zstandard,
               xsltproc,
               zlib1g-dev
Standards-Version: 4.7.0
Homepage: https://taisei-project.org/

Package: taisei
Architecture: any
Depends: taisei-data, ${misc:Depends}, ${shlibs:Depends}
Description: vertical scrolling shooting game
 Taisei Project is an open source fan-game set in the world of Toho Project.
 It is a top-down vertical-scrolling curtain fire shooting game (STG), also
 known as a "bullet hell" or "danmaku." STGs are fast-paced games focused
 around pattern recognition and mastery through practice.

Package: taisei-data
Architecture: all
Depends: ${misc:Depends}
Description: vertical scrolling shooting game (data files)
 Taisei Project is an open source fan-game set in the world of Toho Project.
 It is a top-down vertical-scrolling curtain fire shooting game (STG), also
 known as a "bullet hell" or "danmaku." STGs are fast-paced games focused
 around pattern recognition and mastery through practice.
 .
 This package contains the main data files required for taisei
