## taisei 1.4.4%2Bdfsg

=== meson_options.txt ===
--- 
+++ 
@@ -1,3 +1,11 @@
+
+option(
+    'allocator',
+    type  : 'combo',
+    choices : ['libc', 'mimalloc', 'auto'],
+    value : 'auto',
+    description : 'Which memory allocator to use'
+)
 
 option(
     'developer',
@@ -114,7 +122,14 @@
     'shader_transpiler',
     type : 'feature',
     deprecated : {'true' : 'enabled', 'false' : 'disabled'},
-    description : 'Enable shader trans-compilation (requires shaderc)'
+    description : 'Enable shader trans-compilation (requires glslang)'
+)
+
+option(
+    'shader_transpiler_dxbc',
+    type : 'feature',
+    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
+    description : 'Enable compilation of shaders into DXBC bytecode; required for the D3D11 backend of SDL_GPU'
 )
 
 option(
@@ -127,7 +142,7 @@
 option(
     'r_default',
     type : 'combo',
-    choices : ['auto', 'gl33', 'gles20', 'gles30', 'null'],
+    choices : ['auto', 'gl33', 'gles30', 'sdlgpu', 'null'],
     description : 'Which rendering backend to use by default'
 )
 
@@ -140,19 +155,19 @@
 )
 
 option(
-    'r_gles20',
-    type : 'feature',
-    value : 'disabled',
-    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
-    description : 'Build the OpenGL ES 2.0 renderer (incomplete)'
-)
-
-option(
     'r_gles30',
     type : 'feature',
     value : 'auto',
     deprecated : {'true' : 'enabled', 'false' : 'disabled'},
     description : 'Build the OpenGL ES 3.0 renderer'
+)
+
+option(
+    'r_sdlgpu',
+    type : 'feature',
+    value : 'auto',
+    deprecated : {'true' : 'enabled', 'false' : 'disabled'},
+    description : 'Build the SDL3 GPU renderer'
 )
 
 option(
@@ -204,7 +219,7 @@
     'force_vendored_shader_tools',
     type : 'boolean',
     value : false,
-    description : 'Build shaderc and spirv-cross CLI tools from subprojects even if system versions exist'
+    description : 'Build glslang and spirv-cross CLI tools from subprojects even if system versions exist'
 )
 
 option(
@@ -219,3 +234,9 @@
     type : 'feature',
     description: 'Integrate with the GameMode daemon, if running'
 )
+
+option(
+    'tests',
+    type : 'feature',
+    description : 'Build various test programs'
+)
