=== debian/changelog ===
taisei (1.4.4+dfsg-3) unstable; urgency=low

  * Update debian/patches/0001_zstd_lower_level_on_lowmem_platforms.patch

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Thu, 14 Aug 2025 11:21:02 +0100

taisei (1.4.4+dfsg-2) unstable; urgency=low

  * Add debian/patches/0001_zstd_lower_level_on_lowmem_platforms.patch:
    Use lower compress level on some platforms to fix FTBFS.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Thu, 14 Aug 2025 06:27:58 +0100

taisei (1.4.4+dfsg-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 13 Aug 2025 13:14:26 +0100
