=== debian/control ===
--- 
+++ 
@@ -11,8 +11,7 @@
                libfreetype-dev,
                libopusfile-dev,
                libpng-dev,
-               libsdl2-dev,
-               libsdl2-mixer-dev,
+               libsdl3-dev,
                libssl-dev,
                libwebp-dev,
                libzip-dev,
