=== debian/watch ===
# Compulsory line, this is a version 4 file.
version=4

GitHub hosted projects.
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%, repacksuffix=+dfsg, dversionmangle=auto, repack,compression=xz" \
    https://github.com/taisei-project/taisei/releases \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
